// Generated by gencpp from file ld_msgs/ld_can.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_CAN_H
#define LD_MSGS_MESSAGE_LD_CAN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_can_
{
  typedef ld_can_<ContainerAllocator> Type;

  ld_can_()
    : header()
    , ID(0)
    , LEN(0)
    , DATA()  {
      DATA.assign(0);
  }
  ld_can_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , ID(0)
    , LEN(0)
    , DATA()  {
  (void)_alloc;
      DATA.assign(0);
  }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef uint32_t _ID_type;
  _ID_type ID;

   typedef uint8_t _LEN_type;
  _LEN_type LEN;

   typedef boost::array<uint8_t, 8>  _DATA_type;
  _DATA_type DATA;





  typedef boost::shared_ptr< ::ld_msgs::ld_can_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_can_<ContainerAllocator> const> ConstPtr;

}; // struct ld_can_

typedef ::ld_msgs::ld_can_<std::allocator<void> > ld_can;

typedef boost::shared_ptr< ::ld_msgs::ld_can > ld_canPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_can const> ld_canConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_can_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_can_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/xiaotongliu/CANMessageParser/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_can_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_can_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_can_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_can_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_can_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_can_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "734fafbd7c8bfd2322a2052e0c5e14a2";
  }

  static const char* value(const ::ld_msgs::ld_can_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x734fafbd7c8bfd23ULL;
  static const uint64_t static_value2 = 0x22a2052e0c5e14a2ULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_can";
  }

  static const char* value(const ::ld_msgs::ld_can_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_can_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header header\n\
\n\
uint32 ID\n\
\n\
uint8 LEN\n\
\n\
uint8[8] DATA\n\
\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::ld_msgs::ld_can_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_can_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.ID);
      stream.next(m.LEN);
      stream.next(m.DATA);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_can_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_can_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_can_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "ID: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.ID);
    s << indent << "LEN: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.LEN);
    s << indent << "DATA[]" << std::endl;
    for (size_t i = 0; i < v.DATA.size(); ++i)
    {
      s << indent << "  DATA[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.DATA[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_CAN_H
